package jvm.debugtool;

/**
 * debug tool: Jconsole
 */
public class DeadLockDemo{
    static class SyncAddRunnable implements Runnable {
        int a, b;

        public SyncAddRunnable(int a, int b) {
            this.a = a;
            this.b = b;
        }

        @Override
        public void run() {
            synchronized (Integer.valueOf(a)) {
                try {
                    Thread.sleep(100);
                } catch ( InterruptedException e) {
                    e.printStackTrace();
                }
                synchronized (Integer.valueOf(b)) {
                    System.out.println(a + b);
                }
            }
        }
    }

    public static void main(String[] args) {
        for(int i = 0;i < 100;i++){
            new Thread(new SyncAddRunnable(1,2)).start();
            new Thread(new SyncAddRunnable(2,1)).start();
        }
    }
}
